/*
 * This file is part of SubLink.
 * Copyright (C) 2009  Jeferson Hultmann <hultmann@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

var EXPORTED_SYMBOLS = ["Cc", "Ci", "util"];

var Cc = Components.classes;
var Ci = Components.interfaces;


var util = {

  //assert: function() {


  toTinyUrlRequest: function(uri, browserOrigin, onSuccess, error) {
    if (this.isRedirUri(uri)) {
      throw util.logStack(host);
    }


    var chromeWnd = browserOrigin.ownerDocument.defaultView;
    chromeWnd.setCursor("progress");
    //chromeWnd.getBrowser().selectedBrowser.defaultView.setCursor('progress');

    Components.utils.import("resource://sublink-gremio-modules/api-gremio.js");
    var req = new AsyncRequest();
    var start = new Date().getTime();

    //req.onStart = function() {
      /*
      var e = chromeWnd.document.documentElement;
      util.log('onstart ['+e.className+']');
      e.className = (e.className ? " " : "") + 'migreme-hltmnn-progress';


      e = chromeWnd.getBrowser().selectedBrowser.contentDocument.body;
      util.log('onstart ['+e.className+']');
      e.className = (e.className ? " " : "") + 'migreme-hltmnn-progress';
      */
    //};

    req.onComplete = function() {
      chromeWnd.setCursor("auto");
      util.log("Connection grem.io: " + (new Date().getTime() - start) + "ms");
      /*
      var e = chromeWnd.document.documentElement;
      util.log('onstop ['+e.className+']');
      var t = e.className.split(/\s+/).map(function(i) {
        return i == 'migreme-hltmnn-progress' ? '' : i;
      });
      e.className = t.join(" ");
      */
      //util.log('cursor auto');
    };

    req.onSuccess = function(info) {
      onSuccess(info);
      Components.utils.import("resource://sublink-gremio-modules/redir-storage.js");
      redirStorage.saveShortUrl(uri, info.shortUri);
    };


    if (error) {
      req.onError = error;
    } else {
      req.onError = function(errData) {
        Components.utils.import("resource://sublink-gremio-modules/err.js");
        notificationError(errData, browserOrigin);
      }
    }

    req.convert(uri);
  },


  isRedirUri: function(uri) {

    switch (uri.scheme) {
      case "http":
      case "https":
        break;
      default:
        return false;
    }


    switch (uri.host) {
      case "tumblr.com":
      case "feeds.gawker.com":
      case "feeds.feedburner.com":
      case "feeds.wired.com":
      case "ff.im":
        return true;
      case "digg.com":
        return uri.path.indexOf("/", 1) === -1;
    }


    var tld = Cc["@mozilla.org/network/effective-tld-service;1"]
              .getService(Ci.nsIEffectiveTLDService);

    var baseDomain;
    try {
      baseDomain = tld.getBaseDomain(uri);
    } catch (ex) {
      return false; //e.g.: localhost
    }


    // no path
    if (uri.path.length === 1) { // "/".length=1
      var publicSuffix = tld.getPublicSuffix(uri);
      if (publicSuffix === "tk") { // http://ura71.tk
        return true;
      }

      switch (baseDomain) {
        case "th8.us":
          return true;
      }
      return false;
    }


    if (util.isBitLy(baseDomain)) {
      return true;
    }


    switch (baseDomain) {
      case "shar.es":
      case "me.lt":
      case "arst.ch":
      case "dxurl.com":

      case "t.co":
      case "migre.me":
      case "goo.gl":
      case "youtu.be":
      case "is.gd":
      case "im.ly":
      case "3.ly":  // "3.ly/aaa" ==> "3.ly/aaa/" ==> url
      case "pqp.vc":
      case "flic.kr":
      case "uol.com":
      case "ig.com":
      case "crbug.com":
      case "kingo.to":
      case "fb.me":
      case "bugzil.la":
      case "pud.im":
      case "ru.ly":
      case "grem.io":
        return true;

    // path=/xxxx/
    //if (uri.path.indexOf("/", 1) > 0) {
    //  switch (baseDomain) {
      case "flickr.com":
        return uri.path.indexOf("/p/") === 0;

      case "google.com":
        return uri.host === "feedproxy.google.com";
      //}
      //return false;
    //}
    //switch (baseDomain) { // todo baseDomain OR www + baseDomain

      case "th8.us":
        return uri.path.indexOf("/forw") === 0; // http://th8.us/forward.php?xyz

      case "blip.fm":
        return uri.path.indexOf("/~") === 0 || uri.path.indexOf("/%7E") === 0;

      case "r2.ly":
      case "digs.by":
      case "nyt.com":
      case "zapt.in":
      case "ustre.am":
      case "htxt.it":
      case "om.ly":
      case "p.ly":
      case "fwd4.me":
      case "2tu.us":
      case "adjix.com":
      case "alturl.com":
      case "b23.ru":
      case "bacn.me":
      case "bloat.me":
      case "budurl.com":
      case "chilp.it":
      case "cli.gs":
      case "clipurl.us":
      case "cort.as":
      case "dwarfurl.com":
      case "fff.to":
      case "fit.am":
      case "href.in":
      case "icio.us":
      case "idek.net":
      case "kiq.me":
      case "kl.am":
      case "korta.nu":
      case "lin.cr":
      case "loopt.us":
      case "lost.in":
      case "memurl.com":
      case "merky.de":
      case "mltp.ly":
      case "moby.to":
      case "moourl.com":
      case "nanourl.se":
      case "notlong.com":
      case "okm.me":
      case "ow.ly":
      case "peaurl.com":
      case "ping.fm":
      case "piurl.com":
      case "plurl.me":
      case "pnt.me":
      case "poprl.com":
      case "post.ly":
      case "qik.ly":
      case "qlnk.net":
      case "rde.me":
      case "redir.ec":
      case "retwt.me":
      case "rubyurl.com":
      case "short.ie":
      case "short.to":
      case "shorten.ws":
      case "siga.st":
      case "smallr.com":
      case "sn.im":
      case "sn.vc":
      case "snipr.com":
      case "snipurl.com":
      case "snurl.com":
      case "su.pr":
      case "tiny.cc":
      case "tinysong.com":
      case "tinyurl.com":
      case "tl.gd":
      case "togoto.us":
      case "tr.im":
      case "tra.kz":
      case "trg.li":
      case "trim.li":
      case "trunc.it":
      case "twa.lk":
      case "twurl.cc":
      case "twurl.nl":
      case "u.nu":
      case "ur1.ca":
      case "url.az":
      case "url.ie":
      case "url4.eu":
      case "urlx.ie":
      case "vai.la":
      case "w34.us":
      case "wp.me":
      case "xrl.us":
      case "xurls.info":
      case "yep.it":
      case "yumurl.com":
      case "zi.ma":
      case "zip.li":
      case "zurl.ws":

      case "xn--hgi.ws": // ➡
      case "xn--ogi.ws": // ➨
      case "xn--vgi.ws": // ➯
      case "xn--3fi.ws": // ➔
      case "xn--egi.ws": // ➞
      case "xn--9gi.ws": // ➽
      case "xn--5gi.ws": // ➹
      case "xn--1ci.ws": // ✩
      case "xn--odi.ws": // ✿
      case "xn--rei.ws": // ❥
      case "xn--cwg.ws": // ›
      case "xn--bih.ws": // ⌘
      case "xn--fwg.ws": // ‽
      case "xn--l3h.ws": // ☁
      case "ta.gd":

        return true;
    }

    return false;
  },


  getInfoUrl: function(uri) {
    var tld = Cc["@mozilla.org/network/effective-tld-service;1"].getService(Ci.nsIEffectiveTLDService);
    var baseDomain = tld.getBaseDomain(uri);

    if (util.isBitLy(baseDomain)) {
      return uri.spec + "+";
    }

    switch (baseDomain) {
      case "migre.me": // http://migre.me/ret/xxx
        //var code = uri.path.substr(uri.path.lastIndexOf("/") + 1);
        //return "http://migre.me/contar-cliques/?url="  + encodeURIComponent(code);
      case "goo.gl":
      case "p.ly":
        return uri.spec + "+";
      case "zapt.in":
        return "http://zapt.in/short/" + encodeURIComponent(uri.path.substr(1));
      case "3.ly":
        if (uri.path.lastIndexOf("/") === (uri.path.length - 1)) {
          return null;
        } else {
          return uri.spec + "-";
        }
      case "is.gd":
        return uri.spec + "-";
      case "th8.us":
        if (uri.host !== baseDomain) { // "xxxxx.th8.us" vs. "th8.us"
          var uri2 = uri.clone();
          uri2.host = "p." + uri.host;
          return uri2.spec;
        }
        break;
    }

    return null;
  },

  isBitLy: function(domain) {
    switch (domain) {
      case "4ms.me":
      case "abcn.ws":
      case "ajxn.it":
      case "amzn.to":
      case "aol.it":
      case "bbc.in":
      case "bit.ly": // xxx.bit.ly/123/dddd
      case "cnet.co":
      case "cot.ag":
      case "es.pn":
      case "gaw.kr":
      case "gizmo.do":
      case "glo.bo":
      case "go.nasa.gov":
      case "intel.ly":
      case "j.mp":
      case "lifehac.kr":
      case "lnkd.in":
      case "mzl.la":
      case "nyti.ms":
      case "onion.com":
      case "read.bi":
      case "tcrn.ch":
      case "yhoo.it":
      case "zd.net":
        return true;
    }
    return false;
  },



  get isOsX() {
    return Cc["@mozilla.org/xre/app-info;1"]
            .getService(Ci.nsIXULRuntime)
            .OS === "Darwin";
  },


  toClipboard: function(txt) {
    Cc["@mozilla.org/widget/clipboardhelper;1"]
      .getService(Ci.nsIClipboardHelper)
      .copyString(txt);
  },


  isOffline: function() {
    return Cc["@mozilla.org/network/io-service;1"]
            .getService(Ci.nsIIOService2)
            .offline;
  },


  browserWindowsEnum: function() {
    return Cc["@mozilla.org/appshell/window-mediator;1"]
            .getService(Ci.nsIWindowMediator)
            .getEnumerator("navigator:browser");
  },


  openPage: function(url, where, chromeWin) {
    util.log("openPage=" + url);
    if (util.checkSecurity(util.stringToUri(url)) === false) {
      util.log("openPage security false " + url);
      return;
    }

    if (chromeWin === null) {
      chromeWin = Cc["@mozilla.org/appshell/window-mediator;1"]
                  .getService(Ci.nsIWindowMediator)
                  .getMostRecentWindow("navigator:browser");
    }

    //var referer = chromeWin.getBrowser().selectedBrowser.contentDocument.documentURIObject;
    chromeWin.openUILinkIn(url, where);
    chromeWin.content.focus();
  },


  openPage2: function(evt, url, close) {
    var menuItem = evt.target;
    var chromeWin = menuItem.ownerDocument.defaultView;
    var where;

    switch (evt.type) {
      case "click":
        if ((menuItem.getAttribute("disabled") === "true")
        || (evt.button !== 1)) {
          return; // do nothing
        }
        where = "tabshifted";
        break;
      case "command":
        where = "current";
        break;
      default:
        throw util.logStack(evt.type);
    }

    if (close) {
      chromeWin.closeMenus(menuItem);
    }

    util.openPage(url, where, chromeWin);
  },


  pageTitle: function(uri) {
    return Cc["@mozilla.org/browser/nav-history-service;1"]
            .getService(Ci.nsINavHistoryService)
            .getPageTitle(uri);
  },


  checkSecurity: function (uri) {
    switch (uri.scheme) {
      case "javascript":
      case "data":
        return false;
    }
    return true;
  },


  addClass: function(node, newClass) {
    var current = node.className;
    if (current.length > 0) {
      node.className = current + " " + newClass;
    } else {
      node.className = newClass;
    }
  },

  stringToUri: function(spec) {
    try {
      return Cc["@mozilla.org/network/io-service;1"]
              .getService(Ci.nsIIOService)
              .newURI(spec, "UTF-8", null);
    } catch (ex) {
      return null;
    }
  },

  getText: function(msg) {
    var qty = arguments.length - 1;
    var args = new Array(qty);
    for (var idx = 0; idx < qty; idx++) {
      args[idx] = arguments[idx + 1];
    }
    return Cc["@mozilla.org/intl/stringbundle;1"]
            .getService(Ci.nsIStringBundleService)
            .createBundle("chrome://sublink-gremio/locale/general.properties")
            .formatStringFromName(msg, args, args.length);
  },

  logStack: function(txt) {
    util.log("===Stack===\n" + stack.toString(1));
    return txt;
  },

  log: function(msg) {//status stat
    var now = new Date();
    var p = "sublink-gremio[" + now.toLocaleTimeString() + "." + now.getMilliseconds() + "] ";
    dump("\n------------------------------------------------------------------\n" + p + msg);
    Cc["@mozilla.org/consoleservice;1"]
      .getService(Ci.nsIConsoleService)
      .logStringMessage(p + msg);
  },

  findCurrentUrlPos: function(txt, idx) {
    //var bounds = ["http:", "https:", "ftp:", "www."];
    var bounds = [" ", "\n", "\t", "(", ")", '"', "'", "<", ">", "[", "]"];
    var mySort = function(a, b) {
      return a - b;
    };

    var stopChars = bounds.map(function(myChar) {
      var idx2 = txt.indexOf(myChar, idx);
      return idx2 === -1 ? Infinity : idx2;
    });


    stopChars.sort(mySort);
    var endNearest = stopChars[0];
    var lastChar = (endNearest === Infinity ? txt.length : endNearest) - 1;


    var startChars = bounds.map(function(myChar) {
      return txt.lastIndexOf(myChar, lastChar);
    });

    startChars.sort(mySort);
    var startNearest = startChars[startChars.length - 1];

    var firstChar = startNearest == -1 ? 0 : startNearest + 1;
    return [firstChar, lastChar - firstChar + 1];
  }

};



var stack = {

  toString: function(qtyIgnore) {
    var arr = this._toArray(Components.stack);
    arr.splice(0, 1 + qtyIgnore); // remove stack.toString + util.logStack
    arr.reverse();
    var lines = new Array(arr.length);
    for (var idx = arr.length - 1, idx2 = 0; idx > -1; idx--) {
      var lang = arr[idx].lang + " ";
      lines[idx2] = "[" + (idx + 1) + "] "
                  + lang
                  + arr[idx].filename + " "
                  + arr[idx].name + " ("
                  + arr[idx].lineNumber + ")";
      idx2++;
    }
    return lines.join("\n");
  },

  _toArray: function(theStack) {
    var allItems = [];
    if (!theStack) {
      return allItems;
    }

    function StackItem() {}
    StackItem.prototype = {
      lang: "?",
      filename: "?",
      lineNumber: -1,
      name: "?"
    };

    // aparentemente é um bug que ocorre as vezes, todas as propriedades sao undefined
    if (theStack.languageName == undefined) {
      var item = new StackItem();
      item.name = theStack.toString();
      allItems.push(item);
    }

    // myStack.caller é quase sempre null, mas algumas vezes é undefined...
    for (var myStack = theStack; myStack; myStack = myStack.caller) {
      var item = new StackItem();
      allItems.push(item);
      item.lang = myStack.languageName;
      item.filename = myStack.filename;
      item.lineNumber = myStack.lineNumber; // Valid line numbers begin at "1". "0" indicates unknown.
      item.name = myStack.name;
    }

    return allItems;
  }

};
